xquery version "1.0";

(: Liste der in den Lebensläufen vorkommenden Personen 
es gibt noch kein Register!

1. Liste alle Personen ausgeben -> For-Schleife über die Personen
2. bei gleichen Vorkommen jeweils nur 1X -> WHERE-Bedingung
3. gruppiert nach den Schlüsseln (@key) -> For-Schleife über die unterschiedlichen Schlüssel
:)

declare namespace tei="http://www.tei-c.org/ns/1.0";

declare option exist:serialize "method=xhtml media-type=text/html";

let $lebenslaeufe := collection("/db/lebenslaeufe")
return
<div>
    <h2>Personen gruppiert nach Schlüssel</h2>
    <ul>
       {for $key in distinct-values($lebenslaeufe//tei:persName/@key)
        (: Personen mit diesem Schlüssel :)
        let $personen := $lebenslaeufe//tei:persName[@key = $key]
        (: nach dem Schlüssel sortieren :)
        order by $key
        return
            <li>{data($key)}
                <ul>
                   {(: alle Personen mit diesem Schlüssel ausgeben :)
                    for $person in $personen
                    where $person[not(preceding::tei:persName[data(.) = data($person)])]
                    order by $person
                    return
                        <li title="{$person/@key}">{string-join($person/(child::* | text()), ' ')}<br />
                           <!-- auf welchen Seiten? 
                           Johann Michael Andreä hat keine vorhergehende Seite und Heinrich Urban auch nicht; 
                           kommen beide auf der Titelseite vor -->
                           {for $seite in $lebenslaeufe//tei:persName[data(.) = data($person)]/preceding::tei:pb[1]
                            return concat("S. ", data($seite/@n))}
                        </li>}
                </ul>
            </li>
       }
      
    </ul>
    <h2>alle verschiedenen Personen, die vorkommen</h2>
    <ul>
      {(: nur Personen aus dem Body :)
       for $person in $lebenslaeufe//tei:body//tei:persName 
       where $person[not(preceding::tei:persName[data(.) = data($person)])]
       order by $person
       return
           <li title="{$person/@key}">{string-join($person/(child::* | text()), ' ')}</li>
       }
    </ul>
</div>